import { useUserStore } from "../../store";
import { Api } from "../api/Api";
import { UserDto, UserLoginDto, UserViewModel } from "../api/data-contracts";

export class AuthService {
    private readonly _api: Api;
    
    constructor(api: Api) {
        this._api = api;
        
    }
    async login(data: UserLoginDto) {
        let result = await this._api.auth(data);
        console.log(result);
        const store = useUserStore();
        store.updateUser(result.data);
    }

    logout() {
        const store = useUserStore();
        store.updateUser({} as UserViewModel);
    }

    async register(data: UserDto) {
        let result = await this._api.authRegister(data);
        const store = useUserStore();
        store.updateUser(result.data);
    }
    
}