import { useUserStore } from "../../store";
import { Api } from "../api/Api";
import { ChangeRecordDto, ChangeRecordViewModel } from "../api/data-contracts";

export class ChangeRecordService {
    private readonly _api: Api
    constructor(api: Api) {
        this._api = api;
    }

    private async _updateUser() {
        const store = useUserStore();
        let updatedUser = await this._api.userGet({ Id: store.user.id });

        store.updateUser(updatedUser.data);
    }

    async createRecord(data: ChangeRecordDto) {
        let result = await this._api.changeRecordCreate(data);
        this._updateUser();
        console.log(result);
    }

    async deleteRecord(Id: string) {
        console.log(Id);
        let result = await this._api.changeRecordDelete({ Id });
        this._updateUser();
        console.log("delete");
        console.log(result);
    }

    async getList(): Promise<ChangeRecordViewModel[] | null> {
        const store = useUserStore();
        if (!store.user.id) return null;

        let UserId = store.user.id;
        let result = await this._api.changeRecordFilterList({ UserId });
        
        console.log(result);
        return result.data;
    }
}