import { Api } from "../api/Api";
import { SpendingPlanDto, SpendingPlanViewModel } from "../api/data-contracts";

export class PlanService {
    
    private readonly _api: Api
    constructor(api: Api) {
        this._api = api;
    }

    async deletePlan(Id: string) {
        let result = await this._api.spendingPlanDelete({ Id });
        console.log("delete");
        console.log(result);
    }

    async getList(groupId: string): Promise<SpendingPlanViewModel[] | null> {
        const result = await this._api.spendingGroupDetail(groupId);
        return result.data.spendingPlans || null;
    }

    async createPlan(data: SpendingPlanDto) {
        const result = await this._api.spendingPlanCreate(data);
        console.log(result);
    }
}