import { createApp } from 'vue'
import './style.css'
import App from './App.vue'
import router from './router'
import { Api } from './core/api/Api'
import { createPinia } from 'pinia'
import { AuthService } from './core/services/auth-service'
import { ChangeRecordService } from './core/services/change-record-service'
import { GroupService } from './core/services/group-service'
import { PlanService } from './core/services/plans-service'
import { ReportService } from './core/services/report-service'

const app = createApp(App)

app.use(router)
app.use(createPinia())

// Di
const api = new Api();
app.provide(AuthService.name, new AuthService(api));
app.provide(ChangeRecordService.name, new ChangeRecordService(api));
app.provide(GroupService.name, new GroupService(api));
app.provide(PlanService.name, new PlanService(api));
app.provide(ReportService.name, new ReportService(api));

app.mount('#app')
